import * as s3 from '@aws-cdk/aws-s3';
import * as cdk from '@aws-cdk/core';
import { GlueVersion, GlueWorkerType } from './glue-job';
export interface IGlueNotebookProperties {
    notebookName: string;
    notebookInstanceType: string;
    workerType: GlueWorkerType;
    glueVersion: GlueVersion;
    numberOfWorkers: number;
    region: string;
    accountId: string;
    stage: string;
    readAccessBuckets?: s3.IBucket[];
    writeAccessBuckets?: s3.IBucket[];
    database: string;
}
export declare class GlueNotebook extends cdk.Construct {
    constructor(scope: cdk.Construct, id: string, props: IGlueNotebookProperties);
}
