import { DataCatalogOwner, DataPipelineType, JDBCProperties, S3Properties, S3NotificationProperties, StreamProperties, TableProps, JobProperties, DataSetLocation } from './data-lake';
/**
 * @experimental
 */
export interface IPipelineProperties {
    /**
     * @experimental
     */
    type: DataPipelineType;
    /**
     * @experimental
     */
    name: string;
    /**
     * @experimental
     */
    destinationPrefix: string;
    /**
     * @experimental
     */
    dataSetDropLocation: DataSetLocation;
    /**
     * @experimental
     */
    dataCatalogOwner: DataCatalogOwner;
    /**
     * @experimental
     */
    s3Properties?: S3Properties;
    /**
     * @experimental
     */
    streamProperties?: StreamProperties;
    /**
     * @experimental
     */
    jdbcProperties?: JDBCProperties;
    /**
     * @experimental
     */
    s3NotificationProps?: S3NotificationProperties;
    /**
     * @experimental
     */
    table?: TableProps;
    /**
     * @experimental
     */
    job?: JobProperties;
}
/**
 * @experimental
 */
export declare class Pipeline {
    /**
     * @experimental
     */
    readonly type: DataPipelineType;
    /**
     * @experimental
     */
    readonly name: string;
    /**
     * @experimental
     */
    readonly destinationPrefix: string;
    /**
     * @experimental
     */
    readonly dataSetDropLocation: DataSetLocation;
    /**
     * @experimental
     */
    readonly dataCatalogOwner: DataCatalogOwner;
    /**
     * @experimental
     */
    readonly s3Properties?: S3Properties;
    /**
     * @experimental
     */
    readonly streamProperties?: StreamProperties;
    /**
     * @experimental
     */
    readonly jdbcProperties?: JDBCProperties;
    /**
     * @experimental
     */
    readonly s3NotificationProps?: S3NotificationProperties;
    /**
     * @experimental
     */
    readonly table?: TableProps;
    /**
     * @experimental
     */
    readonly job?: JobProperties;
    /**
     * @experimental
     */
    constructor(props: IPipelineProperties);
}
